"""Our main visual theme"""

import serge.blocks.themes
theme = serge.blocks.themes.Manager()

G = theme.getProperty

W, H = 1024, 768

DAMAGE_BY_CLICK = (248, 242, 226)
CRITICAL_DAMAGE_BY_CLICK = (249, 249, 63)
DMG = (218, 18, 5)
POISON = (29, 197, 117)
SIDE_KICK = (209, 121, 31)
HEAL = (60, 125, 205)


theme.load({
    'main': ('', {

        # Enemies
        'enemies-in-wave': [
            2,  # 1
            3,  # 2
            4,  # 3
            4,  # 4
            4,  # 5
            4,  # 6
            4,  # 7
            4,  # 8
            4,  # 9
            4,  # 10

        ],

        # Shark boss names
        'boss-shark-names': {
            'Shark-1': 'Tiny Chomp',
            'Shark-2': 'Biter Bob',
            'Shark-3': 'Smily Sally',
            'Shark-4': 'Sharp Sid',
            'Shark-5': 'Big Bob',
            'Shark-6': 'Frodo',
            'Shark-7': 'Angry Alice',
            'Shark-8': 'Fearsome',
            'Shark-9': 'The Grunger',
            'Shark-10': 'Death Kiss',
        },

        # Power up screen
        'power-up-order': [
            'Weapon',
            'Armour',
            'Health',
            'Sidekick-A',
            'Sidekick-B',
            'Sidekick-C',
        ],

        # Player
        'initial-hp': 100,

        # Main properties
        'screen-height': H,
        'screen-width': W,
        'screen-title': 'zoonami',
        'screen-icon-filename': 'icon.png',
        'screenshot-size': (0, 0, W, H),
        'screen-center': (W / 2, H / 2),

        # Mute button
        'mute-button-alpha': 0.4,
        'mute-button-position': (30, 30),
        'pre-stop-pause': 0.5,

        # FPS display
        'fps-x': 50,
        'fps-y': H-30,
        'fps-colour': (255, 255, 0),
        'fps-size': 12,

        # Player
        'player-posn': (W / 2 + 50, 150),
        'sidekick-a-posn': (100, 300),
        'sidekick-b-posn': (100, 450),
        'sidekick-c-posn': (100, 600),

        'stage-posn': (580, 450),
        'stage-width': 800,
        'stage-height': 100,

        # Thing UI
        'player-pic-posn': (0, 0),
        'player-name-posn': (0, -80),
        'player-vbox-posn': (0, 60),
        'player-hp-posn': (0, -120),
        'player-hp-text-posn': (0, -135),
        'player-click-posn': (100, 0),
        'player-click-text-posn': (110, 0),
        'player-name': 'Bob',
        'player-name-colour': (255, 255, 255),
        'player-font-name': 'DEFAULT',
        'player-font-size': 32,
        'player-vbox-width': 100,
        'player-vbox-height': 70,
        'player-slot-1-colour': (255, 0, 0),
        'player-slot-2-colour': (255, 255, 255),
        'player-slot-3-colour': (255, 255, 255),
        'player-slot-font-name': 'DEFAULT',
        'player-slot-font-size': 20,
        'player-hp-size': (170, 14),
        'player-click-size': (14, 200),
        'player-action-x-range': (-30, 30),
        'player-action-y-range': (0, 20),

        'hp-colour': (0, 255, 0),
        'hp-font-size': 12,
        'click-colour': (0, 255, 255),
        'click-font-size': 12,

        'sidekick-pic-posn': (0, 0),
        'sidekick-name-posn': (0, -50),
        'sidekick-vbox-posn': (0, 40),
        'sidekick-hp-posn': (0, -60),
        'sidekick-hp-text-posn': (0, -75),
        'sidekick-click-posn': (60, 0),
        'sidekick-click-text-posn': (70, 0),
        'sidekick-name': 'Bob',
        'sidekick-name-colour': (255, 255, 255),
        'sidekick-font-name': 'DEFAULT',
        'sidekick-font-size': 18,
        'sidekick-vbox-width': 60,
        'sidekick-vbox-height': 30,
        'sidekick-slot-1-colour': (255, 0, 0),
        'sidekick-slot-2-colour': (0, 255, 0),
        'sidekick-slot-3-colour': (0, 0, 255),
        'sidekick-slot-font-name': 'DEFAULT',
        'sidekick-slot-font-size': 14,
        'sidekick-hp-size': (170, 14),
        'sidekick-click-size': (5, 100),
        'sidekick-action-x-range': (-30, 30),
        'sidekick-action-y-range': (-95, -85),

        'animal-pic-posn': (0, 0),
        'animal-name-posn': (0, -80),
        'animal-vbox-posn': (0, 90),
        'animal-hp-posn': (0, -120),
        'animal-hp-text-posn': (0, -135),
        'animal-click-posn': (100, 0),
        'animal-click-text-posn': (110, 0),
        'animal-name': 'Bob',
        'animal-name-colour': (255, 255, 255),
        'animal-font-name': 'DEFAULT',
        'animal-font-size': 20,
        'animal-vbox-width': 100,
        'animal-vbox-height': 50,
        'animal-slot-1-colour': (255, 0, 0),
        'animal-slot-2-colour': (0, 255, 0),
        'animal-slot-3-colour': (255, 255, 0),
        'animal-slot-font-name': 'DEFAULT',
        'animal-slot-font-size': 24,
        'animal-hp-size': (170, 14),
        'animal-click-size': (8, 200),
        'animal-action-x-range': (-30, 30),
        'animal-action-y-range': (-95, -55),

        # Strike
        'strike-default': (255, 255, 255),
        'strike-font-size': 24,
        'strike-lifetime': (300, 500),
        'strike-y-vel': (-180.0, -160.0),
        'strike-fade': 0.95,

        'strike-player-click': (248, 242, 226),
        'strike-player-critical-click': (248, 242, 226),
        'strike-sidekick-aof': (209, 121, 31),
        'strike-sidekick-click': (209, 121, 31),
        'strike-sidekick-critical-click': (209, 121, 31),
        'strike-sidekick-heal':  (60, 125, 205),
        'strike-enemy-click': (218, 18, 5),
        'strike-enemy-critical-click': (218, 18, 5),
        'strike-enemy-dot': (29, 197, 117),

        # Gold display
        'gold-posn': (900, 50),
        'gold-pic-posn': (50, 0),
        'gold-text-posn': (-80, 0),
        'gold-text-colour': (230, 190, 81),
        'gold-font-name': 'DEFAULT',
        'gold-font-size': 64,
        'gold-item-font-size': 32,
        'gold-x-vel': (50, 100),
        'gold-y-vel': (-20, 0),
        'gold-y-acc': 1000.0,
        'gold-y-limit': 600,

        # Health display
        'health-posn': (900, 50),
        'health-pic-posn': (50, 0),
        'health-text-posn': (-80, 0),
        'health-text-colour': (60, 125, 205),
        'health-font-name': 'DEFAULT',
        'health-font-size': 64,
        'health-item-font-size': 32,
        'health-x-vel': (-100, -50),
        'health-y-vel': (-20, 0),
        'health-y-acc': 1000.0,
        'health-y-limit': 600,


        'health-multiplier': 1.5,

        # Power up
        'power-up-button-pos': (900, 150),

        # Back
        'back-button-pos': (900, 150),

        # Power up
        'grid-width': 1000,
        'grid-height': 600,
        'grid-posn': (W / 2, H / 2 + 100),

        'power-up-cost-posn': (-150, -30),
        'power-up-name-posn': (-40, -30),
        'power-up-description-posn': (-40, 0),
        'power-up-effects-posn': (-40, 35),
        'power-up-pic-posn': (-120, 20),

        'power-up-text-colour': (230, 190, 81),
        'power-up-effects-colour': (255, 255, 255),
        'power-up-cost-text-colour': (0, 0, 0),
        'power-up-font-name': 'DEFAULT',
        'power-up-cost-size': 32,
        'power-up-font-size': 20,
        'power-up-description-size': 12,
        'power-up-effects-size': 12,
        'power-up-rect-size': (350, 150),
        'power-up-rect-pos': (0, 20),
        'power-up-mouse-time': 100.0,
        'power-up-blanker-colour': (0, 0, 0, 200),

        'power-up-off-colour': {
            'Weapon': (125, 125, 0),
            'Armour': (125, 0, 125),
            'Health': (0, 125, 125),
            'Sidekick-A': (125, 0, 0),
            'Sidekick-B': (0, 0, 125),
            'Sidekick-C': (0, 125, 0),
        },
        'power-up-on-colour': {
            'Weapon': (255, 255, 0),
            'Armour': (255, 0, 255),
            'Health': (0, 255, 255),
            'Sidekick-A': (255, 0, 0),
            'Sidekick-B': (0, 0, 255),
            'Sidekick-C': (0, 0, 255),
        },

        'battle-posn': (W / 2, 700),
        'battle-progress-size': (300, 30),
        'battle-progress-colour': (241, 105, 90),
        'battle-progress-posn': (0, 0),
        'battle-progress-text-posn': (-340, -10),
        'battle-progress-font-size': 24,

        # Next battle
        'next-battle-button-pos': (830, 700),

        'wave-posn': (W / 2, 740),
        'wave-progress-size': (300, 30),
        'wave-progress-colour': (241, 146, 39),
        'wave-progress-posn': (0, 0),
        'wave-progress-text-posn': (-340, -10),
        'wave-progress-font-size': 24,

        # Next wave
        'next-wave-button-pos': (800, 740),

        # Retreat
        'retreat-button-pos': (580, 600),

        # You died
        'you-died-button-pos': (W / 2, H / 2),

        # You won
        'you-won-button-pos': (W / 2, H / 2),

    }),

    'start-screen': ('main', {
        # Logo and title
        'logo-position': (W/2, 140),
        'title': 'zoonami',
        'title-position': (W/2, 300),
        'title-colour': (255, 255, 255, 255),
        'title-font-size': 36,
        # Version text
        'version-position': (W/2, H-10),
        'version-colour': (50, 50, 50),
        'version-font-size': 12,
        # Start button
        'start-1-position': (W/2 - 270, H-120),
        'start-2-position': (W/2 + 270, H-120),
        'start-1-colour': (255, 255, 0, 255),
        'start-1-font-size': 48,
        'start-2-colour': (255, 255, 0, 255),
        'start-2-font-size': 48,
        # Continue button
        'continue-position': (W/2, H-170),
        'continue-colour': (255, 255, 0, 255),
        'continue-font-size': 48,
        # Help button
        'help-position': (W-100, H-40),
        'help-colour': (0, 255, 0, 255),
        'help-font-size': 24,
        # Credits button
        'credits-position': (100, H-40),
        'credits-colour': (0, 255, 0, 255),
        'credits-font-size': 24,
        # Achievements button
        'achievements-position': (W/2, H-40),
        'achievements-colour': (0, 255, 0, 255),
        'achievements-font-size': 24,
    }),

    'sub-screen': ('start-screen', {
        # Logo and title
        'logo-position': (W/2-50, 40),
        'title-position': (W/2+50, 40),
        'title-colour': (255, 255, 255, 255),
        'title-font-size': 36,
        # Back button
        'back-colour': (255, 255, 0, 255),
        'back-font-size': 24,
    }),
    'help-screen': ('sub-screen', {
        # Help text
        'text-position': (W/2, H/2),
    }),
    'credits-screen': ('sub-screen', {
        # Author
        'author-title-colour': (0, 220, 220),
        'author-title-font-size': 24,
        'author-title-position': (W/2, 110),
        'author-colour': (255, 255, 0),
        'author-font-size': 32,
        'author-position': (W/2, 150),
        'url-colour': (255, 0, 0),
        'url-font-size': 14,
        'url-position': (W/2, 170),
        # Music
        'music-title1-colour': (0, 220, 220),
        'music-title1-font-size': 20,
        'music-title1-position': (W/2, 220),
        'music-title2-colour': (0, 220, 220),
        'music-title2-font-size': 18,
        'music-title2-position': (W/2, 240),
        'music-colour': (255, 255, 0),
        'music-font-size': 16,
        'music-position': (W/2, 260),
        # Sound
        'sound-title1-colour': (0, 220, 220),
        'sound-title1-font-size': 20,
        'sound-title1-position': (W/2, 340),
        'sound-title2-colour': (0, 220, 220),
        'sound-title2-font-size': 18,
        'sound-title2-position': (W/2, 360),
        # Built using
        'built-title-colour': (0, 220, 220),
        'built-title-font-size': 20,
        'built-title-position': (W/4, 420),
        'built-colour': (255, 255, 0),
        'built-font-size': 16,
        'built-position': (W/4, 440),
        # Engine
        'engine-title-colour': (0, 220, 220),
        'engine-title-font-size': 20,
        'engine-title-position': (W/4, 480),
        'engine-colour': (255, 255, 0),
        'engine-font-size': 16,
        'engine-position': (W/4, 500),
        # Engine version
        'engine-version-colour': (75, 75, 0),
        'engine-version-font-size': 10,
        'engine-version-position': (W/4, 520),
        # Fonts
        'font-title1-colour': (0, 220, 220),
        'font-title1-font-size': 20,
        'font-title1-position': (W*3/4, 420),
        'font-title2-colour': (0, 220, 220),
        'font-title2-font-size': 18,
        'font-title2-position': (W*3/4, 440),
        'font-colour': (255, 255, 0),
        'font-font-size': 16,
        'font-position': (W*3/4, 460),
        #
        'back-position': (100, H-40),

    }),

    'intro-screen': ('help-screen', {}),

    'achievements': ('main', {
        # Properties of the achievements system
        'banner-duration': 5,
        'banner-position': (175, 525),
        'banner-size': (300, 50),
        'banner-backcolour': (0, 0, 0, 50),
        'banner-font-colour': (255, 255, 0, 255),
        'banner-name-size': 14,
        'banner-description-size': 8,
        'banner-name-position': (-100, -18),
        'banner-description-position': (-100, 0),
        'banner-font-name': 'DEFAULT',
        'banner-graphic-position': (-125, 0),

        'time-colour': (255, 255, 255, 100),
        'time-size': 10,
        'time-position': (-100, 24),

        'logo-position': (400, 50),
        'screen-background-sprite': None,
        'screen-background-position': (400, 300),
        'grid-size': (2, 5),
        'grid-width': 800,
        'grid-height': 400,
        'grid-position': (400, 320),

        'back-colour': (255, 255, 255, 255),
        'back-font-size': 20,
        'back-font-name': 'DEFAULT',
        'back-position': (400, 560),
        'back-sound': 'click',
    }),

    '__default__': 'main',

})

